var {
  THREE,
  Edge,
  Node,
  OrbitControls,
  d3,
  ee,
  DEF_NODE_COLOR,
  DEF_NODE_HIGHLIGHT,
  DEF_ADJACENT_HIGHLIGHT,
  DEF_NODE_HTEXTURE,
  DEF_NODE_TEXTURE,
  DEF_NODE_NO_HTEX,
  DEF_NODE_NO_TEX,
  DEF_NODE_NO_HCOLOR,
  DEF_NODE_NO_COLOR,
  DEF_NODE_NO_HIGHLIGHT,
  DEF_NODE_SHAPE,
  DEF_NODE_HSHAPE,
  DEF_NODE_SIZE,
  DEF_LAYOUT,
  DEF_LINES,
  DEF_MAP,
  DEF_TEXT_SCALE,
  DEF_TEXT_SIZE,
  DEF_TEXT_X_OFFSET,
  DEF_TEXT_Y_OFFSET,
  DEF_TEXT_BACK_COLOR,
  DEF_TEXT_OPACITY,
  TEXT_WIREFRAME
} = require('./imports').default;
var Utils = require('./utils/utils');

module.exports = function (self) {
  /**
   *  ADDS Nodes to a selection whose "label" data matches the passed node_label
   */
  //TODO: This does not work with new graph structure
  self.searchNodes = function (node_label) {
    foundNode = false;
    nodes = self.graph.nodes;

    nodeLabelList = nodes.map(function (node) {
      return node.renderData['label'];
    });

    for (var i = 0; i < nodeLabelList.length; i++) {
      if (nodeLabelList[i] == node_label) {
        self.selection.push(nodes[i]);
        foundNode = true;
      }
    }

    self.updateSelection(0, 0);

    return foundNode;
  }

  //TODO: Change node.renderData in innermost for loop to be node.domainData
  self.getSelectedData = function () {
    result = ""
    if (self.selection != undefined & self.selection.length > 0) {
      for (i = 0; i < self.selection.length; i++) {
        node = self.selection[i];
        for (dataItem in node.renderData) {
          result += dataItem + ": " + node.renderData[dataItem].toString() + "\n"
        }
        result += "\n"
      }
    }
    return result;
  }

  /**
   * Change camera on window resize
   */
  self.onWindowResize = function () {
    self.clientRect = self.element.getBoundingClientRect();
    self.width = self.clientRect.width;
    self.height = self.clientRect.height;
    self.aspect = self.width / self.height;
    self.ccamera.aspect = self.aspect;
    self.ccamera.updateProjectionMatrix();
    if (DEF_MAP == "yes") {
      self.ccamera2.aspect = self.aspect;
      self.ccamera2.updateProjectionMatrix();
    }

    self.renderer.setSize(self.width, self.height);
    self.cssRenderer.setSize(self.width, self.height);
  }
}